Resources (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.resources, class: Resources

# Class Resources

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.resources.Resources

All Implemented Interfaces:
  `Cloneable, Iterable<Resource>, ResourceCollection, AppendableResourceCollection`

public class Resources extends DataType implements AppendableResourceCollection
Generic `ResourceCollection`: Either stores nested `ResourceCollection`s, making no attempt to remove duplicates, or references another `ResourceCollection`.

Since:
  Ant 1.7

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Iterator<Resource>`
  `EMPTY_ITERATOR`
  `static` empty `Iterator`
  `static final ResourceCollection`
  `NONE`
  `static` empty `ResourceCollection`

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Resources()`
  Create a new `Resources`.
  `Resources(Project project)`
  Create a new `Resources`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(ResourceCollection c)`
  Add a `ResourceCollection`.
  `protected void`
  `dieOnCircularReference(Stack<Object> stk, Project p)`
  Overrides the base implementation to recurse on all `DataType` child elements that may have been added.
  `protected void`
  `invalidateExistingIterators()`
  Allow subclasses to notify existing Iterators they have experienced concurrent modification.
  `boolean`
  `isFilesystemOnly()`
  Fulfill the `ResourceCollection` contract.
  `Iterator<Resource>`
  `iterator()`
  Fulfill the `ResourceCollection` contract.
  `void`
  `setCache(boolean b)`
  Set whether to cache collections.
  `int`
  `size()`
  Fulfill the `ResourceCollection` contract.
  `String`
  `toString()`
  Format this `Resources` as a `String`.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, setRefid, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `void`
  `setRefid(Reference ref)`
  Set the value of the refid attribute.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ResourceCollection

  `isEmpty, stream`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isEmpty()`
  Learn whether this `ResourceCollection` is empty.
  `default Stream<? extends Resource>`
  `stream()`
  Return a `Stream` over this `ResourceCollection`.

- ## Field Details

  - ### NONE

    public static final ResourceCollection NONE
    `static` empty `ResourceCollection`

  - ### EMPTY_ITERATOR

    public static final Iterator<Resource> EMPTY_ITERATOR
    `static` empty `Iterator`

- ## Constructor Details

  - ### Resources

    public Resources()
    Create a new `Resources`.

  - ### Resources

    public Resources(Project project)
    Create a new `Resources`.
    Parameters:
      `project` - `Project`
    Since:
      Ant 1.8

- ## Method Details

  - ### setCache

    public void setCache(boolean b)
    Set whether to cache collections.
    Parameters:
      `b` - `boolean` cache flag.
    Since:
      Ant 1.8.0

  - ### add

    public void add(ResourceCollection c)
    Add a `ResourceCollection`.
    Specified by:
      `add` in interface `AppendableResourceCollection`
    Parameters:
      `c` - the `ResourceCollection` to add.

  - ### iterator

    public Iterator<Resource> iterator()
    Fulfill the `ResourceCollection` contract.
    Specified by:
      `iterator` in interface `Iterable<Resource>`
    Returns:
      an `Iterator` of `Resources`.

  - ### size

    public int size()
    Fulfill the `ResourceCollection` contract.
    Specified by:
      `size` in interface `ResourceCollection`
    Returns:
      number of elements as `int`.

  - ### isFilesystemOnly

    public boolean isFilesystemOnly()
    Fulfill the `ResourceCollection` contract.
    Specified by:
      `isFilesystemOnly` in interface `ResourceCollection`
    Returns:
      `true` if all `Resource`s represent files.

  - ### toString

    public String toString()
    Format this `Resources` as a `String`.
    Overrides:
      `toString` in class `DataType`
    Returns:
      a descriptive `String`.

  - ### dieOnCircularReference

    protected void dieOnCircularReference(Stack<Object> stk, Project p) throws BuildException
    Overrides the base implementation to recurse on all `DataType` child elements that may have been added.
    Overrides:
      `dieOnCircularReference` in class `DataType`
    Parameters:
      `stk` - the stack of data types to use (recursively).
      `p` - the `Project` to use to dereference the references.
    Throws:
      `BuildException` - on error.

  - ### invalidateExistingIterators

    protected void invalidateExistingIterators()
    Allow subclasses to notify existing Iterators they have experienced concurrent modification.